# file: problemset4.ml
#  author: Bob Muller
#

SUCC = 1
FAIL = 0

# IGNORE THE FOLLOW DEFS ###############################
#
def assert_eqf(msg, f, expected):
    print "Running: " + msg + "..."
    outcome = SUCC if f() == expected else FAIL
    if outcome == SUCC:
        print "test passed!"
    else:
        print "test failed. :-("

def assert_eq(msg, actual, expected):
    return assert_eqf(msg, (lambda : actual), expected)

def run_test(msg, f):
    return assert_eqf(msg, f, True)

# END OF IGNORE PART ###################################

# PROBLEM 1:
#
def last(xs):
    if xs == []:
        return "last: cannot give last of empty list."
    else:
        first = xs[0]
        rest = xs[1:]
        if rest == []:
            return first
        else:
            return last(rest)

def test(): 
  return (last([2.0, 3.0, 4.0]) == 4.0)
run_test("last test", test)


def isFactor(m, n): return n % m == 0

def addEvens(ns):
    if ns == []:
        return 0
    else:
        m = ns[0]
        ms = ns[1:]
        if isFactor(2, m):
            return m + addEvens(ms)
        else:
            return addEvens(ms)

def test(): 
  return (addEvens([2.0, 3.0, 4.0]) == 6.0)
run_test("addEvens test", test)


def member(x, xs):
    if xs == []:
        return False
    else:
        y = xs[0]
        ys = xs[1:]
        if x == y:
            return True
        else:
            return member(x, ys)

def removeDuplicates(xs):
    if xs == []:
        return []
    else:
        y = xs[0]
        ys = xs[1:]
        if member(y, ys):
            return removeDuplicates(ys)
        else:
            return [y] + removeDuplicates(ys)

def test(): 
 return (removeDuplicates([2.0, 2.0, 3.0, 4.0]) == [2.0, 3.0, 4.0])
run_test("removeDuplicates test", test)


def isAscending(xs):
    if len(xs) < 2:
        return True
    else:
        x = xs[0]
        y = xs[1]
        ys = xs[2:]
        if x < y:
            return isAscending(xs[1:])
        else:
            return False

def test1():
    return (isAscending([2.0, 3.0, 4.0]) == True)
def test2():
    return (isAscending([2.0, 3.0, 3.0]) == False)
run_test("isAscending test", test1)
run_test("isAscending test", test2)


def powerList(xs):
    if xs == []:
        return [[]]
    else:
        y = xs[0]
        ys = xs[1:]
        ws = powerList(ys)
        vs = map(lambda zs: [y] + zs, ws)
        return vs + ws

def test(): 
  return (len(powerList([1, 2, 3])) == 8)
run_test("powerList test", test)


def insert(x, ys):
    if ys == []:
        return [x]
    else:
        z = ys[0]
        zs = ys[1:]
        if x < z:
            return [x] + ys
        else:
            return [z] + insert(x, zs)

def test(): 
  return (insert(3, [1, 2, 4]) == [1, 2, 3, 4])
run_test("insert test", test)


def split(xs):
    n = len(xs) / 2
    def loop(m, ys, zs):
        if  m == 0:
            return (zs, ys)
        else:
            w = ys[0]
            ws = ys[1:]
            (front, back) = loop(m - 1, ws, zs)
            return ([w] + front, back)
    return loop(n, xs, [])
def test(): 
  return (split([1, 2, 5, 4, 3]) == ([1, 2], [5, 4, 3]))
run_test("split test", test)

def merge(xs, ys):
    if xs == [] and ys == []:
        return []
    elif xs == []:
        return ys
    elif ys == []:
        return xs
    else:
        (w, ws) = (xs[0], xs[1:])
        (z, zs) = (ys[0], ys[1:])
        if w < z:
            return [w] + merge(ws, ys)
        else:
            return [z] + merge(xs, zs)
def test(): 
  return (merge([2], [1, 3]) == [1, 2, 3])
run_test("merge test", test)

def mergeSort(xs):
    if len(xs) < 2:
        return xs
    else:
        (ys, zs) = split(xs)
        return merge(mergeSort(ys), mergeSort(zs))
def test(): 
  return (mergeSort([3, 2, 1]) == [1, 2, 3])
run_test("mergeSort test", test)

def almostInsertionSort(xs, ys):
    if xs == []:
        return ys
    else:
        z = xs[0]
        zs = xs[1:]
        ws = insert(z, ys)
        return almostInsertionSort(zs, ws)
def test(): 
  xs = [4, 1, 8]
  ys = [3, 5, 7]
  return (almostInsertionSort(xs, ys) == [1, 3, 4, 5, 7, 8])
run_test( "almostInsertionSort test", test)

def insertionSort(xs):
  return almostInsertionSort(xs, [])
def test(): 
  return (insertionSort([3, 2, 1]) == [1, 2, 3])
run_test("insertionSort test", test)


def antiCons(xs):
    if xs == []:
        return "antiCons: unhappy"
    else:
        if len(xs) == 1:
            return (xs[0], [])
        else:
            y =xs[0]
            ys = xs[1:]
            (z, zs) = antiCons(ys)
            return (z, [y] + zs)
def test(): 
  return antiCons([3, 2, 1]) == (1, [3, 2])
run_test("antiCons test", test)

def isPalindrome(s):
    n = len(s) - 1
    if n < 1:
        return True
    else:
        return s[0] == s[n] and isPalindrome(s[1:n])


def test1(): 
  return isPalindrome("able was I ere I saw elba") == True
def test2():
  return isPalindrome("able was I ere I saw Elba") == False
run_test("isPalindrome test1", test1)
run_test("isPalindrome test2", test2)

def zip (xs, ys):
    return [ (xs[i], ys[i]) for i in range(len(xs)) ]

def test(): 
  return zip(["A", "B"], [26, 25]) == [("A", 26), ("B", 25)]
run_test("zip test", test)

def unzip(xs):
    return ([x for (x, _) in xs], [y for (_, y) in xs])

def test(): 
  return unzip([("A", 26), ("B", 25)]) == (["A", "B"], [26, 25])
run_test("unzip test", test)

print "problemset3.py: ran to completion"
